<?php
/**
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the GNU General Public License (GPL 3)
 * that is bundled with this package in the file LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade Payone_Core to newer
 * versions in the future. If you wish to customize Payone_Core for your
 * needs please refer to http://www.payone.de for more information.
 *
 * @category        Payone
 * @package         Payone_Core_Block
 * @subpackage      Payment
 * @copyright       Copyright (c) 2015 <kontakt@fatchip.de> - www.fatchip.com
 * @author          Robert Mller <robert.mueller@fatchip.de>
 * @license         <http://www.gnu.org/licenses/> GNU General Public License (GPL 3)
 * @link            http://www.fatchip.com
 */

class Payone_Core_Block_Payment_Method_Form_Payolution extends Payone_Core_Block_Payment_Method_Form_Abstract
{
    
    protected $_sAcceptanceBaseUrl = 'https://payment.payolution.com/payolution-payment/infoport/dataprivacydeclaration?mId=';

    protected $hasTypes = true;
    
    protected $_sFallback = "<header>
  <strong>Zustzliche Hinweise fr die Datenschutzerklrung fr Kauf auf Rechnung, Ratenzahlung und Zahlung mittels SEPA-Basis-Lastschrift von **company** (im Folgenden: wir)</strong></br>
  <span><i>(Stand: 17.03.2016)</i></span>
</header>
<ol>
  <li><p>Bei Kauf auf Rechnung oder Ratenzahlung oder SEPA-Basis-Lastschrift wird von Ihnen whrend des Bestellprozesses eine datenschutzrechtliche Einwilligung eingeholt. Folgend finden Sie eine Wiederholung dieser Bestimmungen, die lediglich informativen Charakter haben.</p></li>
  <li><p>Bei Auswahl von Kauf auf Rechnung oder Ratenzahlung oder Bezahlung mittels SEPA-Basis-Lastschrift werden fr die Abwicklung dieser Zahlarten personenbezogene Daten (Vorname, Nachname, Adresse, Email, Telefonnummer, Geburtsdatum, IP-Adresse, Geschlecht) gemeinsam mit fr die Transaktionsabwicklung erforderlichen Daten (Artikel, Rechnungsbetrag, Zinsen, Raten, Flligkeiten, Gesamtbetrag, Rechnungsnummer, Steuern, Whrung, Bestelldatum und Bestellzeitpunkt) an payolution bermittelt werden. payolution hat ein berechtigtes Interesse an den Daten und bentigt bzw. verwendet diese um Risikoberprfungen durchzufhren.</p></li>
  <li>
  	<p>Zur berprfung der Identitt bzw. Bonitt des Kunden werden Abfragen und Ausknfte bei ffentlich zugnglichen Datenbanken sowie Kreditauskunfteien durchgefhrt. Bei nachstehenden Anbietern knnen Ausknfte und gegebenenfalls Bonittsinformationen auf Basis mathematisch-statistischer Verfahren eingeholt werden:</p>
  	<ul>
		<li>CRIF GmbH, Diefenbachgasse 35, A-1150 Wien</li>
		<li>CRIF AG, Hagenholzstrasse 81, CH-8050 Zrich</li>
		<li>Deltavista GmbH, Dessauerstrae 9, D-80992 Mnchen</li>
		<li>SCHUFA Holding AG, Kormoranweg 5, D-65201 Wiesbaden</li>
		<li>KSV1870 Information GmbH, Wagenseilgasse 7, A-1120 Wien</li>
		<li>Brgel Wirtschaftsinformationen GmbH & Co. KG, Gasstrae 18, D-22761 Hamburg</li>
		<li>Creditreform Boniversum GmbH, Hellersbergstr. 11, D-41460 Neuss</li>
		<li>infoscore Consumer Data GmbH, Rheinstrae 99, D-76532 Baden-Baden</li>
		<li>ProfileAddress Direktmarketing GmbH, Altmannsdorfer Strasse 311, A-1230 Wien</li>
		<li>Deutsche Post Direkt GmbH, Junkersring 57, D-53844 Troisdorf</li>
		<li>payolution GmbH, Am Euro Platz 2, A-1120 Wien</li>
	</ul>
	<p>payolution wird Ihre Angaben zur Bankverbindung (insbesondere Bankleitzahl und Kontonummer) zum Zwecke der Kontonummernprfung an die SCHUFA Holding AG bermitteln. Die SCHUFA prft anhand dieser Daten zunchst, ob die von Ihnen gemachten Angaben zur Bankverbindung plausibel sind. Die SCHUFA berprft, ob die zur Prfung verwendeten Daten ggf. in Ihrem Datenbestand gespeichert sind und bermittelt sodann das Ergebnis der berprfung an payolution zurck. Ein weiterer Datenaustausch wie die Bekanntgabe von Bonittsinformationen oder eine bermittlung abweichender Bankverbindungsdaten sowie Speicherung Ihrer Daten im SCHUFA-Datenbestand finden im Rahmen der Kontonummernprfung nicht statt. Es wird aus Nachweisgrnden allein die Tatsache der berprfung der Bankverbindungsdaten bei der SCHUFA gespeichert.</p>
	<p>payolution ist berechtigt, auch Daten zu etwaigem nicht-vertragsgemen Verhalten (z.B. unbestrittene offene Forderungen) zu speichern, zu verarbeiten, zu nutzen und an oben genannte Auskunfteien zu bermitteln.</p>
  </li>
  <li><p>Wir sind bereits nach den Bestimmungen des Brgerlichen Gesetzbuches ber Finanzierungshilfen zwischen Unternehmern und Verbrauchern, zu einer Prfung Ihrer Kreditwrdigkeit gesetzlich verpflichtet.</p></li>
  <li><p>Im Fall eines Kaufs auf Rechnung oder Ratenkauf oder einer Bezahlung mittels SEPA-Basis-Lastschrift werden der payolution GmbH Daten ber die Aufnahme (zu Ihrer Person, Kaufpreis, Laufzeit des Teilzahlungsgeschfts, Ratenbeginn) und vereinbarungsgeme Abwicklung (z.B. vorzeitige Rckzahlung, Laufzeitverlngerung, erfolgte Rckzahlungen) dieses Teilzahlungsgeschfts bermittelt. Nach Abtretung der Kaufpreisforderung wird die forderungsbernehmende Bank die genannten Datenbermittlungen vornehmen. Wir bzw. die Bank, der die Kaufpreisforderung abgetreten wird, werden payolution GmbH auch Daten aufgrund nichtvertragsgemer Abwicklung (z.B. Kndigung des Teilzahlungsgeschfts, Zwangsvollstreckungs-manahmen) melden. Diese Meldungen drfen nach den datenschutzrechtlichen Bestimmungen nur erfolgen, soweit dies zur Wahrung berechtigter Interessen von Vertragspartnern der payolution GmbH oder der Allgemeinheit erforderlich ist und dadurch Ihre schutzwrdigen Belange nicht beeintrchtigt werden. payolution GmbH speichert die Daten, um ihren Vertragspartnern, die gewerbsmig Teilzahlungs- und sonstige Kreditgeschfte an Verbraucher geben, Informationen zur Beurteilung der Kreditwrdigkeit von Kunden geben zu knnen. An Unternehmen, die gewerbsmig Forderungen einziehen und payolution GmbH vertraglich angeschlossen sind, knnen zum Zwecke der Schuldnerermittlung Adressdaten bermittelt werden. payolution GmbH stellt die Daten ihren Vertragspartnern nur zur Verfgung, wenn diese ein berechtigtes Interesse an der Datenbermittlung glaubhaft darlegen. payolution GmbH bermittelt nur objektive Daten ohne Angabe der Bank; subjektive Werturteile sowie persnliche Einkommens- und Vermgensverhltnisse sind in Ausknften der payolution GmbH nicht enthalten.</p></li>
  <li><p>Die im Bestellprozess durch Einwilligung erfolgte Zustimmung zur Datenweitergabe kann jederzeit, auch ohne Angabe von Grnden, uns gegenber widerrufen knnen. Die oben genannten gesetzlichen Verpflichtungen zur berprfung Ihrer Kreditwrdigkeit bleiben von einem allflligen Widerruf jedoch unberhrt. Sie sind verpflichtet ausschlielich wahrheitsgetreue Angaben gegenber uns zu machen.</p></li>
  <li><p>Sollten Sie Auskunft ber die Erhebung, Nutzung, Verarbeitung oder bermittlung von Sie betreffenden personenbezogenen Daten erhalten wollen oder Ausknfte, Berichtigungen, Sperrungen oder Lschung dieser Daten wnschen, knnen Sie sich an den Sachbearbeiter fr Datenschutz bei payolution wenden:</p></li>
</ol>

<footer>Sachbearbeiter fr Datenschutz<br />
	datenschutz@payolution.com<br />
	payolution GmbH<br />
	Am Euro Platz 2<br />
	1120 Wien<br />
	DVR: 4008655
</footer>";
    
    protected $_aBackendBlacklist = array(
        Payone_Api_Enum_PayolutionType::PYS
    );
    
    protected function _construct() 
    {
        parent::_construct();
        $this->setTemplate('payone/core/payment/method/form/payolution.phtml');
    }

    public function getPayolutionType() 
    {
        if($this->_sType === null) {
            $aTypes = $this->getMethod()->getConfig()->getTypes();
            $this->_sType = array_shift($aTypes);
        }

        return $this->_sType;
    }
    
    public function getPayolutionTypes() 
    {
        return $this->getMethod()->getConfig()->getTypes();
    }
    
    public function getPayolutionTypesBackend() 
    {
        $aTypes = $this->getPayolutionTypes();
        
        $aTypesReturn = array();
        foreach ($aTypes as $sType) {
            if(array_search($sType, $this->_aBackendBlacklist) === false) {
                $aTypesReturn[] = $sType;
            }
        }

        return $aTypesReturn;
    }
    
    /**
     * @return bool
     */
    public function isDobRequired()
    {
        // required for all countries
        // required only if customer didn't enter Dob in previous checkout step
        $customerDob = $this->getQuote()->getCustomerDob();
        if (empty($customerDob)) {
            return true;
        }

        return false;
    }

    /**
     * @return bool
     */
    public function isTelephoneRequired()
    {
        // telephone is mandatory for any country in case of Klarna
        $telephone = $this->getQuote()->getBillingAddress()->getTelephone();
        if (empty($telephone)) {
            return true;
        }

        return false;
    }
    
    public function isB2BMode() 
    {
        if((bool)$this->getMethod()->getConfig()->getB2bMode() === true) {
            $sCompany = $this->getQuote()->getBillingAddress()->getCompany();
            if($sCompany) {
                return true;
            }
        }

        return false;
    }
    
    public function showBirthdayFields() 
    {
        if($this->isB2BMode() === false) {
            return true;
        }

        return false;
    }
    
    public function showDebitFields() 
    {
        if ($this->getPayolutionType() == Payone_Api_Enum_PayolutionType::PYD) {
            return true;
        }

        return false;
    }
    
    protected function _getFallbackText($sCompany) 
    {
        $sFallback = str_replace('**company**', $sCompany, $this->_sFallback);
        return $sFallback;
    }
    
    protected function _isUtf8EncodingNeeded($sString) 
    {
        if (preg_match('!!u', $sString)) {
            // this is utf-8
            return false;
        } else {
            // definitely not utf-8
            return true;
        }
    }
    
    public function getPayolutionAcceptanceText() 
    {
        $sCompany = $this->getMethod()->getConfig()->getCompanyName();
        $sUrl = $this->_sAcceptanceBaseUrl.base64_encode($sCompany);
        $sContent = file_get_contents($sUrl);
        $sPage = false;
        if(!empty($sContent) && stripos($sContent, 'payolution') !== false && stripos($sContent, '<header>') !== false) {
            //Parse content from HTML-body-tag from the given page
            $sRegex = "#<\s*?body\b[^>]*>(.*?)</body\b[^>]*>#s";
            preg_match($sRegex, $sContent, $aMatches);
            if(is_array($aMatches) && count($aMatches) > 1) {
                $sPage = $aMatches[1];
                //remove everything bevore the <header> tag ( a window.close link which wouldn't work in the given context )
                $sPage = substr($sPage, stripos($sPage, '<header>'));
            }
        }

        if(!$sPage) {
            $sPage = $this->_getFallbackText($sCompany);
        }

        if($this->_isUtf8EncodingNeeded($sPage)) {
            $sPage = utf8_encode($sPage);
        }

        return $sPage;
    }
    
    /**
     * @return array
     */
    protected function getSystemConfigMethodTypes()
    {
        return $this->getFactory()->getModelSystemConfigPayolutionType()->toSelectArray();
    }
    
    public function getHandleInstallmentUrl()
    {
        return $this->getUrl('payone_core/checkout_onepage/handlePayolutionInstallment');
    }
    
}